//################################################################################
//# Project: Fire Curtain System
//# Company: [Company Name]
//# Author: Supriya Kore
//# Date: 20-July-2023 --> Demo
//# Description: [Brief description of the project or code block]
//#
//# [Brake Motor Working]
//#
//# [Company Name]
//# [Company Address]
//# [Company Website]
//# [Contact Information]
//################################################################################
//CONFIG_ESP_SYSTEM
/*********************************Header Files***********************************/
#include "Arduino.h"
#include <stdint.h>
#include <stdio.h>
#include <Wire.h>
#include <Ticker.h>
#include <ESP32TimerInterrupt.h>
#include <ESP32TimerInterrupt.hpp>
#include <Wire.h>
#include <LiquidCrystal_I2C.h>
#include "PCF8574.h"

#include "Fire_Curtain.h"
#include "Motor.h"
#include "Buzzer.h"
#include "Scan.h"
/*********************************Variable Declaration***************************/
State_t enumCurrentState, enumPreviousState;                //State Variable Declaration
//extern debounceTmr debounceTimer;
//extern timers Timers;
uint8_t previousTimer = 0;
uint8_t previousTimer1 = 0;
uint8_t previousTimer2 = 0;
bool toggleState = false;
/*********************************Main Function**********************************/
void setup() {
  // put your setup code here, to run once:

  /*****************************************************************************/
  Serial.begin(BAUD_RATE);                                  //Initializing Serial Monitor with baud rate of 115200
  // Interval in microsecs
  ITimer1.attachInterruptInterval(TIMER1_INTERVAL_MS * 1000, TimerHandler1);

  disableCore0WDT();
  disableCore1WDT();
  
  Wire.begin(I2C_SDA,I2C_SCL);
  lcd.init();                     
  lcd.backlight();
  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print("Fire Curtain Sys");
  lcd.setCursor(0,1);
  lcd.print("   V1_00_001    ");

  pcf8574.pinMode(SystemOn, OUTPUT);
  pcf8574.pinMode(FireAlarm, OUTPUT);
  pcf8574.pinMode(ManOverride, OUTPUT);
  pcf8574.pinMode(MotorON, OUTPUT);
  pcf8574.pinMode(CommFault, OUTPUT);
  pcf8574.pinMode(BatteryFault, OUTPUT);
  pcf8574.pinMode(MainsFail, OUTPUT);
  pcf8574.pinMode(Wifi, OUTPUT);

    Serial.print("Init pcf8574...");
  if (pcf8574.begin()){
    Serial.println("OK");
  } else {
    Serial.println("KO");
  }
pcf8574.digitalWrite(SystemOn, LOW);
pcf8574.digitalWrite(FireAlarm, HIGH);
pcf8574.digitalWrite(ManOverride, HIGH);
pcf8574.digitalWrite(MotorON, HIGH);
pcf8574.digitalWrite(CommFault, HIGH);
pcf8574.digitalWrite(BatteryFault, HIGH);
pcf8574.digitalWrite(MainsFail, HIGH);
pcf8574.digitalWrite(Wifi, HIGH);
  /******************************OUTPUT PINs************************************/
  pinMode(PFC, OUTPUT);                                 // TBD
  pinMode(SIREN, OUTPUT);                                   //Set pinMode of SIREN as OUTPUT
  pinMode(BUZZER, OUTPUT);                                  //Set pinMode of BUZZER as OUTPUT

  pinMode(M1_UP, OUTPUT);                                   //Set pinMode of M1_UP as OUTPUT
  pinMode(M1_DOWN, OUTPUT);                                 //Set pinMode of M1_DOWN as OUTPUT
  pinMode(M2_UP, OUTPUT);                                   //Set pinMode of M2_UP as OUTPUT
  pinMode(M2_DOWN, OUTPUT);                                 //Set pinMode of M2_DOWN as OUTPUT

  /*******************************INPUT PINs**************************************/

  pinMode(BEAM_DETECTOR_M1, INPUT_PULLUP);                  //Set pinMode of BEAM_DETECTOR_M1 as INPUT_PULLUP
  pinMode(SMOKE_DETECTOR, INPUT_PULLUP);                    //Set pinMode of SMOKE_DETECTOR as INPUT_PULLUP
  pinMode(FIRE_PANEL_INPUT , INPUT_PULLUP);                 //Set pinMode of FIRE_PANEL_INPUT as INPUT_PULLUP
  pinMode(KEY_SWITCH_UP , INPUT_PULLUP);                    //Set pinMode of KEY_SWITCH_UP as INPUT_PULLUP
  pinMode(KEY_SWITCH_DOWN , INPUT_PULLUP);                  //Set pinMode of KEY_SWITCH_DOWN as INPUT_PULLUP
  pinMode(OVERRIDE_SWITCH, INPUT_PULLUP);                   //Set pinMode of OVERRIDE_SWITCH as INPUT_PULLUP
  pinMode(BATT_MONITOR, INPUT);
//  pinMode(MAINS, INPUT);

/***********************************KEYPAD KEYS*************************************/
pinMode(MENU_KEY, INPUT_PULLUP);
pinMode(REST_RIGHT_SHIFT_KEY, INPUT_PULLUP);
pinMode(ENTER_KEY, INPUT_PULLUP);
pinMode(LEFT_SHIFT_KEY, INPUT_PULLUP);
pinMode(UP_KEY, INPUT_PULLUP);
pinMode(DOWN_KEY, INPUT_PULLUP);

  analogReadResolution(ADC_RESOLUTION);                     //Set analog-to-digital conversion resolution to 12 bits
  M1_M2_Stop();
  enumCurrentState = STATE_INIT;
  enumPreviousState = enumCurrentState;                     // Transition to State Init.
}

void loop()
{
delay(10);
  switch (enumCurrentState)
  {
    case STATE_INIT:                                        // Case State STATE_INIT
//      Serial.println("INIT State");
   
      BuzzerOff();                                                                                    // Initialy Buzzer OFF.
      SirenOff();                                                                                     // Initally Siren Off
      ISR_Timer.setTimer(50, irqGenericTimer, 1);
      enumPreviousState = enumCurrentState;
      enumCurrentState = STATE_READY;
      break;

    case STATE_READY:                                       // Case State STATE_READY
//      Serial.println("Ready State");
/***************************************************************************/
        if((boolSystemNormalFlag == true) && (boolMainsFailFlag == false) && (boolBatteryLowFlag == false)) //&& (boolvariable2 == false) && (boolvariable1 = false))
        {
//          lcd.clear();
          lcd.setCursor(0,0);
          lcd.print("Fire Curtain Sys");
          lcd.setCursor(0,1);
          lcd.print("     FCS_02     ");
        }

//      if(debounceTimer.KeyDown_tmr == 0)
//      {
//        debounceTimer.KeyDown_tmr = 5;
//        Serial.println(debounceTimer.KeyDown_tmr);
//      }
//      MainsStatus();   //Check the status of Mains
      Batt_Mon();
      inputScan();
      if(FireMtrStop_tmr != previousTimer)
      {
        previousTimer = FireMtrStop_tmr;
        Serial.print("FireMtrStop ");
        Serial.println(FireMtrStop_tmr);
      }

//      if(Timers.BeamMtrUp_tmr != previousTimer1)
//      {
//        previousTimer1 = Timers.BeamMtrUp_tmr;
//        Serial.print("BeamMtrUp ");
//        Serial.println(Timers.BeamMtrUp_tmr);
//      }

      if(KeyUpRelFire_tmr != previousTimer2)
      {
        previousTimer2 = KeyUpRelFire_tmr;
        Serial.print("KeyUpRelFire_tmr ");
        Serial.println(KeyUpRelFire_tmr);
      }
      if (boolSmokeInterrupt || boolFirePanelInterrupt || boolKeyDownInterrupt || boolKeyUpInterrupt || boolBeamM1Interrupt || boolOverrideSwitchInterrupt || 
      boolBeamAbsSmkFireWait)
      {
        enumPreviousState = enumCurrentState;
        enumCurrentState = STATE_MOTOR_CONTROL;                        //Go to the STATE_MOTOR_CONTROL if any interrupt arrived
        break;
      }
      if(boolSmokeTimerOver || boolFireTimerOver || boolBeamTimerOver || boolBattryLowTimerOver || boolBeamPresentWait || boolMotorStop || boolMotorStop1 || boolMotorStop2)
      {
        enumPreviousState = enumCurrentState;
        enumCurrentState = STATE_MOTOR_STOP;                        //Go to the STATE_MOTOR_CONTROL if any interrupt arrived
        break;
      }

      enumPreviousState = enumCurrentState;
      enumCurrentState = STATE_READY;                                  //If no interrupt arrived then remain in Ready State
      break;

    case STATE_MOTOR_CONTROL:                                          // Case State STATE_MOTOR_CONTROL
      Serial.println("Motor Control State");
      /*********************************Smoke and Fire Panel Input Start****************************************/
//      Serial.print("boolSmokeInterrupt ");
//      Serial.println(boolSmokeInterrupt);
      
      Serial.print("boolFirePanelInterrupt ");
      Serial.println(boolFirePanelInterrupt);
      
//      Serial.print("boolKeyDownInterrupt ");
//      Serial.println(boolKeyDownInterrupt);
//      
//      Serial.print("boolKeyUpInterrupt ");
//      Serial.println(boolKeyUpInterrupt);
//      
//      Serial.print("boolBeamM1Interrupt ");
//      Serial.println(boolBeamM1Interrupt);
      
      Serial.print("boolOverrideSwitchInterrupt ");
      Serial.println(boolOverrideSwitchInterrupt);
      
//       if (boolSmokeInterrupt) 
//      {
//         boolSystemNormalFlag = false;
//          M1_M2_Down();                                               //Turning ON the M1 and M2 in downward direction
//          pcf8574.digitalWrite(MotorON, LOW);                         //Turn ON MotorON LED
//          BuzzerOn();                                                 //Turning ON the Buzzer
//          SirenOn();                                                  //Turning ON the Siren
//          lcd.clear();
//          lcd.setCursor(0, 0);
//          lcd.print(" Smoke Detected ");
//          Timers.SmokeMtrStop_tmr = 30;
//          boolSmokeInterrupt = false;                                   //Reset the smoke interrupt flag
//      }

       if (boolFirePanelInterrupt) 
      {
         boolSystemNormalFlag = false;
          M1_M2_Down();                                               //Turning ON the M1 and M2 in downward direction
            Serial.println("M1_M2_Down");
          pcf8574.digitalWrite(MotorON, LOW);                         //Turn ON MotorON LED
          BuzzerOn();                                                 //Turning ON the Buzzer
          SirenOn();                                                  //Turning ON the Siren
          lcd.clear();
          lcd.setCursor(0,0);
          lcd.print(" Fire Detected  ");
          FireMtrStop_tmr = 30;
          boolFirePanelInterrupt = false;                               //Reset the fire panel interrupt flag
      }

      /********************************* OverRide Switch *******************************************************/

      if(boolOverrideSwitchInterrupt)
      {
        if(boolOverrideSwitchPressed == true)
        {
          M1_M2_Up();
            Serial.println("Motor UP");
          pcf8574.digitalWrite(MotorON, LOW);                         //Turn ON MotorON LED
          BuzzerOn();                                                  //Turning ON the Buzzer when M1 and M2 going upward
//          SirenOn();                                                   //Turning ON the Siren when M1 and M2 going upward
        }
        else if(boolOverrideSwitchPressed == false)
        {
          M1_M2_Stop();
          Serial.println("M1_M2_Stop");
          delay(25);
          if(digitalRead(FIRE_PANEL_INPUT) == LOW)
          {
            M1_M2_Down();
              Serial.println("M1_M2_Down");
            OverrideRelFire_tmr = 30;  //15 secs
          }
          else
          {
          pcf8574.digitalWrite(MotorON, HIGH);                         //Turn ON MotorON LED
          BuzzerOff();                                                 //Turning Off the Buzzer when M1 and M2 stopped
//          SirenOff();                                                  //Turning Off the Siren when M1 and M2 stopped
          }
        }
        boolOverrideSwitchInterrupt = false;
      }

      /*********************************Beam Detector Start*********************************************/
      if (boolBeamM1Interrupt) 
      {                                                            //Checking if Beam_M1 interrupt arrived or not
          M1_M2_Stop();                                                 //Stop the M1 if Beam_M1 is detected
          delay(100);                                              
          M1_M2_Up();                                                 //Up the M1 if Beam_M1 is active
          pcf8574.digitalWrite(MotorON, LOW);                         //Turn ON MotorON LED
          lcd.clear();
          lcd.setCursor(0,0);
          boolBeamFireWait = true;         //if beam detected after fire then motor should stop after beam timer
          lcd.print(" Beam Detected  ");
          BeamMtrUp_tmr = 30 - FireMtrStop_tmr;
          boolBeamM1Interrupt = false;                               //Reset the Beam M1 interrupt flag
      }


      /*********************************Key Down and Key Up Start****************************************/

     if(boolKeyDownInterrupt) 
     {                                      //Checking if Key Down interrupt arrived or not
        if (boolKeySwitchDownPressed) 
        {                                //Checking if Key Down is pressed or Not
          M1_M2_Down();                                                //Turning ON the M1 and M2 Down when key down is pressed
          pcf8574.digitalWrite(MotorON, LOW);                         //Turn ON MotorON LED
          BuzzerOn();                                                  //Turning ON the Buzzer when M1 and M2 going downward
//          SirenOn();                                                   //Turning ON the Siren when M1 and M2 going downward
        } 
        else 
        {
          M1_M2_Stop();                                                //Stoping the M1 and M2 Down when key down is released
          pcf8574.digitalWrite(MotorON, HIGH);                         //Turn ON MotorON LED
          BuzzerOff();                                                 //Turning Off the Buzzer when M1 and M2 stopped
//          SirenOff();                                                  //Turning Off the Siren when M1 and M2 stopped
        }
        boolKeyDownInterrupt = false;                                 //Reset Key Down interrupt flag
      }

      if(boolKeyUpInterrupt) 
       {                                      //Checking if Key Up interrupt arrived or not
        if (boolKeySwitchUpPressed)
        {                                //Checking if Key Up is pressed or Not
          M1_M2_Up();                                                //Turning ON the M1 and M2 Up when key Up is pressed
          Serial.println("M1_M2_Up");
          pcf8574.digitalWrite(MotorON, LOW);                         //Turn ON MotorON LED
          BuzzerOn();                                                //Turning ON the Buzzer when M1 and M2 going downward
//          SirenOn();                                                 //Turning ON the Siren when M1 and M2 going downward
        } 
        else 
        {
          M1_M2_Stop();                                              //Stoping the M1 and M2 Down when key down is released
          Serial.println("M1_M2_Stop");
          delay(25);
          if(digitalRead(FIRE_PANEL_INPUT) == LOW)
          {
            M1_M2_Down();
              Serial.println("M1_M2_Down");
            KeyUpRelFire_tmr = 30;  //15 secs
          }
          else
          {
          pcf8574.digitalWrite(MotorON, HIGH);                         //Turn ON MotorON LED
          BuzzerOff();                                                 //Turning Off the Buzzer when M1 and M2 stopped
//          SirenOff();                                                  //Turning Off the Siren when M1 and M2 stopped
          }
        }
        boolKeyUpInterrupt = false;                                  //Reset Key Up interrupt flag
      }

      if(boolBeamAbsSmkFireWait)
      {
            M1_M2_Down();
            pcf8574.digitalWrite(MotorON, LOW);                         //Turn ON MotorON LED
            BuzzerOn();
            MtrStop_tmr = 30;  //30 secs
            boolBeamAbsSmkFireWait = false;
      }
        
      enumPreviousState = enumCurrentState;
      enumCurrentState = STATE_READY;                                //Go to the STATE_READY
      break;

    case STATE_MOTOR_STOP:
        Serial.println("STATE_MOTOR_STOP");
        
        Serial.print("boolSmokeTimerOver");   //not required now
        Serial.println(boolSmokeTimerOver);

        Serial.print("boolFireTimerOver");  //done
        Serial.println(boolFireTimerOver);

        Serial.print("boolBeamTimerOver");  //done
        Serial.println(boolBeamTimerOver);

        Serial.print("boolBattryLowTimerOver");   //done
        Serial.println(boolBattryLowTimerOver);

        Serial.print("boolBeamPresentWait");  //done
        Serial.println(boolBeamPresentWait);

        Serial.print("boolMotorStop");
        Serial.println(boolMotorStop);
        if(boolSmokeTimerOver)
        {
              M1_M2_Stop();    
              pcf8574.digitalWrite(MotorON, HIGH);      //Turn off the MotorON LED
              BuzzerOff();
              boolSmokeTimerOver = false;
              //boolvariable1 = false;
        }

        if(boolFireTimerOver)
        {
              M1_M2_Stop();    
              pcf8574.digitalWrite(MotorON, HIGH);      //Turn off the MotorON LED
              BuzzerOff();
              boolFireTimerOver = false;
              //boolvariable2 = false;
        }

        if(boolBeamTimerOver)
        {
            M1_M2_Stop();    
            pcf8574.digitalWrite(MotorON, HIGH);        //Turn off the MotorON LED
            BuzzerOff();
            BeamWait_tmr = 10;  //5 secs
            boolBeamTimerOver = false;
        }

        if(boolBattryLowTimerOver)
        {
              M1_M2_Stop();
              pcf8574.digitalWrite(MotorON, HIGH);   //Turn off the MotorON LED
              boolBattryLowTimerOver = false;
        }

        if(boolBeamPresentWait)
        {
             M1_M2_Stop();    
             pcf8574.digitalWrite(MotorON, HIGH);    //Turn off the MotorON LED
             BuzzerOff();
             BeamWait_tmr = 10;  //5 secs
             boolBeamPresentWait = false;
        }

       if(boolMotorStop || boolMotorStop1 || boolMotorStop2)
       {
          M1_M2_Stop();    
          pcf8574.digitalWrite(MotorON, HIGH);   //Turn off the MotorON LED
          BuzzerOff();
          boolMotorStop = false;
          boolMotorStop1 = false;
          boolMotorStop2 = false;
       }
       
        enumPreviousState = enumCurrentState;
        enumCurrentState = STATE_READY;                                 //Go to the INIT_READY
        break;
      
    case STATE_ERROR:                                                // Case State STATE_ERROR
//      Serial.println("Error State");
      enumPreviousState = enumCurrentState;
      enumCurrentState = STATE_INIT;                                 //Go to the INIT_STATE
      break;
  }
}



bool IRAM_ATTR TimerHandler1(void * timerNo)
{
    ISR_Timer.run();
    return true;
}


void irqGenericTimer()
{
  count50ms++;     

  if(count50ms > 5)   //50msx5 = 250ms  but actual is 500ms
  {
       count50ms = 0;
       if(testTimer)
       {
        testTimer--;
       }

    
      if(Fire_tmr)
      {
        Fire_tmr--;
      }

      if(Beam_tmr)
      {
        Beam_tmr--;
      }
      
      if(KeyUp_tmr)
      {
        KeyUp_tmr--;
      }

      if(KeyDown_tmr)
      {
        KeyDown_tmr--;
      }
      
      if(Override_tmr)
      {
        Override_tmr--;
      }
      
//      if(Timers.SmokeMtrStop_tmr)
//      {
//        Timers.SmokeMtrStop_tmr--;
//      }
      
      if(FireMtrStop_tmr)
      {
        FireMtrStop_tmr--;
        if(FireMtrStop_tmr == 0)
        {
          if((boolBeamFireWait == false) && (boolOverrideSwitchPressed == false) && (boolKeySwitchUpPressed == false))
          {
          boolFireTimerOver = true;
          }
        }
      }

      if(BeamMtrUp_tmr)
      {
       BeamMtrUp_tmr--; 
       if(BeamMtrUp_tmr == 0)
       {
        boolBeamTimerOver = true;
       }
      }

    if(BattLowMtrStop_tmr)
    {
      BattLowMtrStop_tmr--;
      if(BattLowMtrStop_tmr == 0)
      {
        boolBattryLowTimerOver = true;
      }
    }

    if(BeamWait_tmr)
    {
      BeamWait_tmr--;
      if(BeamWait_tmr == 0)
      {
        if(digitalRead(BEAM_DETECTOR_M1) == LOW)
        {
          boolBeamPresentWait = true;
        }
        else if((digitalRead(FIRE_PANEL_INPUT) == LOW) && (digitalRead(BEAM_DETECTOR_M1) == HIGH))   //in motor top position if beam deactivated and fire still preset
        {
          boolBeamAbsSmkFireWait = true;
        }
      }
    }

    if(MtrStop_tmr)
    {
      MtrStop_tmr--;
      if(MtrStop_tmr == 0)
      {
        boolMotorStop = true;
      }
    }

    if(OverrideRelFire_tmr)
    {
      OverrideRelFire_tmr--;
      if(OverrideRelFire_tmr == 0)
      {
        boolMotorStop1 = true;
      }
    }

    if(KeyUpRelFire_tmr)
    {
      KeyUpRelFire_tmr--;
      if(KeyUpRelFire_tmr == 0)
      {
        boolMotorStop2 = true;
      }
    }
  }

/******************************Keypad keys***********************************/

if(digitalRead(MENU_KEY) == LOW)
{
  
}
  ISR_Timer.setTimer(50, irqGenericTimer, 1);

  return;
}
