/*********************************Header Files***********************************/
#include <stdint.h>
#include "Motor.h"
#include "Buzzer.h"
#include "Scan.h"


void inputScan()
{
  /********************Fire Panel Input Scan***************************/
    if((digitalRead(FIRE_PANEL_INPUT) == LOW) && (Fire_Flag == false))
    {
      if(Fire_tmr == 0)
      {
         if(FireDeb_Flag == 2)
        {
          FireDeb_Flag = 1;
          boolFirePanelInterrupt = true;      //Set the flag if Smoke Interrupt arrived
          Fire_Flag = true;
        }
        else
        {
          Fire_tmr = 4;  //2secs
          FireDeb_Flag = 2;
        }
      }
    }
    else if(digitalRead(FIRE_PANEL_INPUT) == HIGH)
    {
          Fire_tmr = 0;
          boolSmokeInterrupt = false;      
          Fire_Flag = false;
    }
/**********************Beam Detector Input Scan*****************************/
    if((digitalRead(BEAM_DETECTOR_M1) == LOW) && (Beam_M1_Flag == false))
    {
      if(Beam_tmr == 0)
      {
        if(BeamDeb_Flag == 2)
        {
          boolBeamM1Interrupt = true;
          BeamDeb_Flag = 1;
          Beam_M1_Flag = true;
        }
        else
        {
          Beam_tmr = 4;   //2 secs
          BeamDeb_Flag = 2;
        }
      }
    }
    else if(digitalRead(BEAM_DETECTOR_M1) == HIGH)
    {
      Beam_tmr = 0;
      Beam_M1_Flag = false;
      boolBeamM1Interrupt = false;
    }
/*****************************Key Switch Down Input Scan*****************/
    if((digitalRead(KEY_SWITCH_DOWN) == LOW) && (boolKeyDownFlag == false))
    {
      if(KeyDown_tmr == 0)
      {
        if(KeyDownDeb_Flag == 2)
        {
          KeyDownDeb_Flag = 1;
          boolKeyDownFlag = true;
          boolKeyDownInterrupt = true;
          boolKeySwitchDownPressed = true;
        }
        else
        {
          KeyDown_tmr = 4; //1 secs
          KeyDownDeb_Flag = 2;
        }
      }
    }
    else if((digitalRead(KEY_SWITCH_DOWN) == HIGH) && (boolKeyDownFlag == true))
    {
      if(KeyDown_tmr == 0)
      {
        if(KeyDownDeb_Flag == 2)
        {
          KeyDownDeb_Flag = 1;
          boolKeyDownInterrupt = true;
          boolKeySwitchDownPressed = false;
          boolKeyDownFlag = false;
        }
        else
        {
          KeyDown_tmr = 4; //1 secs
          KeyDownDeb_Flag = 2;
        }
      }
    }
    else
    {
      KeyDown_tmr = 0;
    }

/*****************************Key Switch Up Input Scan*****************/
    if((digitalRead(KEY_SWITCH_UP) == LOW) && (boolKeyUpFlag == false))
    {
      if(KeyUp_tmr == 0)
      {
        if(KeyUpDeb_Flag == 2)
        {
          KeyUpDeb_Flag = 1;
          boolKeyUpFlag = true;
          boolKeyUpInterrupt = true;
          boolKeySwitchUpPressed = true;
        }
        else
        {
          KeyUp_tmr = 4; //1 secs
          KeyUpDeb_Flag = 2;
        }
      }
    }
    else if((digitalRead(KEY_SWITCH_UP) == HIGH) && (boolKeyUpFlag == true))
    {
        if(KeyUp_tmr == 0) 
        {
           if(KeyUpDeb_Flag == 2)
           {
              boolKeyUpInterrupt = true;
              KeyUpDeb_Flag = 1;
              boolKeySwitchUpPressed = false;
              boolKeyUpFlag = false;
           }
           else
           {
              KeyUp_tmr = 4; //1 secs
              KeyUpDeb_Flag = 2; 
           }
         }
    }
    else
    {
     KeyUp_tmr = 0;
    }

/*************************Override Input Scan****************************/
    if((digitalRead(OVERRIDE_SWITCH) == LOW) && (boolOverrideKeyFlag == false))
    {
      if(Override_tmr == 0)
      {
        if(OverrideDeb_Flag == 2)
        {
          OverrideDeb_Flag = 1;
          boolOverrideKeyFlag = true;
          boolOverrideSwitchInterrupt = true;
          boolOverrideSwitchPressed = true;
        }
        else
        {
          Override_tmr = 4; //2 secs
          OverrideDeb_Flag = 2;
        }
      }
    }
    else if((digitalRead(OVERRIDE_SWITCH) == HIGH) && (boolOverrideKeyFlag == true))
    {
      if(Override_tmr == 0)
      {
        if(OverrideDeb_Flag == 2)
        {
          OverrideDeb_Flag = 1;
          boolOverrideSwitchInterrupt = true;
          boolOverrideSwitchPressed = false;
          boolOverrideKeyFlag = false;
        }
        else
        {
          Override_tmr = 4;  //2 secs
          OverrideDeb_Flag = 2;
        }
      }
    }
    else
    {
      Override_tmr = 0;
    }

}


void Batt_Mon()
{
  if((analogRead(BATT_MONITOR) < 3725) && (analogRead(BATT_MONITOR) < 3775))  // 22.6V
  {
    if(boolBatteryLowMotorFlag == false)
    {
      M1_M2_Down();
      pcf8574.digitalWrite(MotorON, LOW);   //Turn ON the MotorON LED
      BuzzerOn();
      boolSystemNormalFlag = false;
      boolBatteryLowFlag = true;
//      lcd.clear();
      lcd.setCursor(0,1);
      lcd.print(" Battery Low    ");
      pcf8574.digitalWrite(BatteryFault, LOW);
      BattLowMtrStop_tmr = 30;
//      ISR_Timer.setTimer(15000, timerBatteryLow, 1);
    }
  }
  else if(analogRead(BATT_MONITOR) > 3875)
  {
    boolBatteryLowMotorFlag = false;
    boolSystemNormalFlag = true;
    boolBatteryLowFlag = false;
    pcf8574.digitalWrite(BatteryFault, HIGH);
//    BuzzerOff();
  }
}

//void MainsStatus()
//{
//  if(digitalRead(MAINS) == HIGH)
//  {
//    pcf8574.digitalWrite(MainsFail, HIGH);
//    if(boolMainsFailFlag)
//    {
//       BuzzerOff();
//       boolSystemNormalFlag = true;
//       lcd.clear();
//       boolMainsFailFlag = false;
//    }
//  }
//  else if(digitalRead(MAINS) == LOW)
//  {
//    boolMainsFailFlag = true;
//    boolSystemNormalFlag = false;
////    lcd.clear();
//    if(boolBatteryLowFlag == false)
//    {
//        lcd.setCursor(0,0);
//        lcd.print("  Mains Fail    ");
//        lcd.setCursor(0,1);
//        lcd.print("                ");
//    }
//    pcf8574.digitalWrite(MainsFail, LOW);
//    BuzzerOn();
//  }
//}
